#include "Commande.h"
#include "Communication.h"

//Traitement de la commande reçue
void execute(void) {
    
    if (checksumOK()) {

      if (strcmp(commandeRecue, LEDVERTE) == 0) {
        ledVerte();
        Serial.println("OK");
      }
      
      else if (strcmp(commandeRecue, LEDROUGE) == 0) {
        ledRouge();
        Serial.println("OK");
      }

      else if (strcmp(commandeRecue, MOVE_FORWARD) == 0) {
        moveForward();
        Serial.println("OK");
      }

      else if (strcmp(commandeRecue, MOVE_BACKWARD) == 0) {
        moveBackward();
        Serial.println("OK");
      }

      else if (strcmp(commandeRecue, MOVE_RIGHT) == 0) {
        moveRight();
        Serial.println("OK");
      }

      else if (strcmp(commandeRecue, MOVE_LEFT) == 0) {
        moveLeft();
        Serial.println("OK");
      }

      else if (strcmp(commandeRecue, STOP) == 0) {
        stop_robot();
        Serial.println("OK");
      }


      else if (strcmp(commandeRecue, MEASURE_SENSORS) == 0) {
        measureSensors();
      }

      /* Pour l'envoi d'une valeur de capteur par trame */

//      else if (strcmp(commandeRecue, GET_DISTANCE) == 0) {
//        capteur_distance();
//      }
//
//      else if (strcmp(commandeRecue, GET_LINEFOLLOWERG) == 0) {
//        suiveur_ligneG();
//      }
//
//      else if (strcmp(commandeRecue, GET_LINEFOLLOWERC) == 0) {
//        suiveur_ligneC();
//      }
//
//      else if (strcmp(commandeRecue, GET_LINEFOLLOWERD) == 0) {
//        suiveur_ligneD();
//      }
      
    }
}

void ledVerte(void) {

  digitalWrite(LEDVERTE_PIN, HIGH);
  delay(100);
  digitalWrite(LEDVERTE_PIN, LOW);

}

void ledRouge(void) {
  
  digitalWrite(LEDROUGE_PIN, HIGH);
  delay(100);
  digitalWrite(LEDROUGE_PIN, LOW);

}

void moveForward(void) {
  
  digitalWrite(AIN1, HIGH);
  digitalWrite(AIN2, LOW);

  digitalWrite(BIN1, HIGH);
  digitalWrite(BIN2, LOW);
  
  analogWrite(PWMA, 64);
  analogWrite(PWMB, 64);
  
}

void moveBackward(void) {
  
  digitalWrite(AIN1, LOW);
  digitalWrite(AIN2, HIGH);

  digitalWrite(BIN1, LOW);
  digitalWrite(BIN2, HIGH);
  
  analogWrite(PWMA, 64);
  analogWrite(PWMB, 64);
  
}

void moveLeft(void) {
  
  digitalWrite(AIN1, HIGH);
  digitalWrite(AIN2, LOW);

  digitalWrite(BIN1, LOW);
  digitalWrite(BIN2, LOW);

  analogWrite(PWMA, 64);
  digitalWrite(PWMB, LOW);
  
}

void moveRight(void) {
  
  digitalWrite(AIN1, LOW);
  digitalWrite(AIN2, LOW);

  digitalWrite(BIN1, HIGH);
  digitalWrite(BIN2, LOW);
  
  analogWrite(PWMB, 64);
  digitalWrite(PWMA, LOW);
  
}

void stop_robot(void) {
 
  digitalWrite(AIN1, LOW);
  digitalWrite(AIN2, LOW);

  digitalWrite(BIN1, LOW);
  digitalWrite(BIN2, LOW);
  
  digitalWrite(PWMA, LOW);
  digitalWrite(PWMB, LOW);
  
}

void measureSensors() {
  int distance = capteur_distance();
  int lineSensorG = suiveur_ligneG();
  int lineSensorC = suiveur_ligneC();
  int lineSensorD = suiveur_ligneD();
  setupPacket(distance, lineSensorG, lineSensorC, lineSensorD);
  Serial.println(reponse);
  
}

const unsigned long TIMEOUT = 25000UL; // 25ms = ~8m à 340m/s

int capteur_distance(void) {
   
   //Envoie d'une pulsation sur TRIGGER pour lancer une mesure
   digitalWrite(TRIG, HIGH);
   delayMicroseconds(10);
   digitalWrite(TRIG, LOW);
   //Mesure le temps entre l'envoi et la réception du signal
   long mesure = pulseIn(ECHO,HIGH,TIMEOUT);
   //On prend juste un aller
   mesure = mesure/2; 
     
   float temps = mesure/1000000.0; //conversion en sec
   int distance = (temps*340)*1000; //d = v*t puis conversion en mm

   //Restriction pour avoir toujours 3 caractères à envoyer
   if (distance > 999) {
    distance = 999;
   }

   else if (distance < 100) {
    distance = 100;
   }

   return distance;  
}

int suiveur_ligne(const int numeroSuiveur) {

  int value = analogRead(numeroSuiveur);
  //Restriction pour avoir toujours 3 caractères à envoyer
  if (value > 999 ) {
    value = 999;
  }
  else if (value < 100 ) {
    value = 100;
  }
  return value;
}

int suiveur_ligneD() {
 
  return suiveur_ligne(LINED);

}

int suiveur_ligneC() {
  
  return suiveur_ligne(LINEC);

}

int suiveur_ligneG() {

  return suiveur_ligne(LINEG);

}

/* Fonctions pour l'envoi d'une trame par valeur de capteur */

//const unsigned long TIMEOUT = 25000UL; // 25ms = ~8m à 340m/s
//
//void capteur_distance(void) {

//   //Envoie d'une pulsation sur TRIGGER pour lancer une mesure
//   digitalWrite(TRIG, HIGH);
//   delayMicroseconds(10);
//   digitalWrite(TRIG, LOW);
//   //Mesure le temps entre l'envoi et la réception du signal
//   long mesure = pulseIn(ECHO,HIGH,TIMEOUT);
//   //On prend juste un aller
//   mesure = mesure/2; 
//     
//   float temps = mesure/1000000.0; //conversion en sec
//   int distance = (temps*340)*1000; //d = v*t puis conversion en mm
//
//   if (distance > 999) {
//    distance = 999;
//   }
//
//   else if (distance < 100) {
//    distance = 100;
//   }
//     
//   setupPacket(GET_DISTANCE,distance);
//   Serial.println(reponse);
//}
//
//void suiveur_ligne(char * numeroCommande, const int numeroSuiveur) {
//
//  int value = analogRead(numeroSuiveur);
//  if (value > 999 ) {
//    value = 999;
//  }
//  else if (value < 100 ) {
//    value = 100;
//  }
//
//  setupPacket(numeroCommande, value);
//  Serial.println(reponse);
//  
//}
//
//void suiveur_ligneD() {

//  suiveur_ligne(GET_LINEFOLLOWERD, LINED);

//}
//
//void suiveur_ligneC() {

//  suiveur_ligne(GET_LINEFOLLOWERC, LINEC);

//}
//
//void suiveur_ligneG() {

//  suiveur_ligne(GET_LINEFOLLOWERG, LINEG);

//}
