#include "Communication.h"

//Stockage trame :
char serialBuffer[14];
char trame[15];
char commandeRecue[3];
char paramsRecues[4];
char checksumRecu[5];

//Stockage reponse :
//Stockage trame réponse pour l'envoi d'une trame pour les valeurs de tous les capteurs
char reponse[24];
//Stockage trame réponse pour l'envoi d'une trame par valeur de capteur
//char reponse[14];

/* ---- FONCTIONS DE LECTURE ----*/

//Lecture des trames reçues
void lireTrame(void) {
  int nbCharLus = 0;
  while (Serial.available() > 0 && nbCharLus <= 14) {
    trame[nbCharLus] = Serial.read();
    nbCharLus++;
    delay(5);
  }
  trame[nbCharLus] = '\0';
}

//Ancienne fonction de lecture qui provoquait une latence de communication importante
//void lireTrame(void) {
//  
//  if (Serial.find("S-")) {
//    Serial.readBytes(serialBuffer,14);
//    strcpy(trame, "S-");
//    strlcpy(trame + strlen(trame), serialBuffer, strlen(serialBuffer)+1);
//    trame[15] = '\0';
//    Serial.println(trame);
//    
//  }
//}

//Découpage de la trame reçue
void parseTrame(void) {

  //On vérifie que le caractère de début est bien 'S'
  if ( strncmp(trame, "S", 1) == 0) {
    //Copie de la trame reçue pour vérifier le checksum après
    char temp[15];
    strcpy(temp, trame);

    char * index;
    index = strtok(temp, "-");

    index = strtok(NULL, "-");
    strcpy(commandeRecue, index);
    
    index = strtok(NULL, "-");
    strcpy(paramsRecues, index);
    
    index = strtok(NULL, "-");
    strcpy(checksumRecu, index);
    
  }

  else {
    //Serial.println("Trame incorrecte");
  }
}

//Vérification du checksum de la trame reçue
boolean checksumOK(void) {
  
  int checksum = 0;
  for (int i=0; i<9;i++) {
    checksum += trame[i];
  }
  checksum += '-'; 
  checksum += 'E';

  if (checksum == atoi(checksumRecu)) {
    trame[0] = '\0';
    return true;
  }

  else {
    return false;
  }
}

/* ---- FONCTIONS DE REPONSE ----*/

//char * setupPacket(char * commande, int valeur) {
//
//  char sValeur[3];
//  itoa(valeur, sValeur, 10);
//  
//  char * reponse = malloc(18 * sizeof(char));
//  strlcpy(reponse, "S-", strlen("S-")+1);
//  strlcpy(reponse + strlen(reponse), commande, strlen(commande)+1);
//  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);
//  strlcpy(reponse + strlen(reponse), sValeur, strlen(sValeur)+1);
//  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);
//  int iChecksum = setChecksum(reponse);
//  char sChecksum[3];
//  itoa(iChecksum, sChecksum, 10);
//  strlcpy(reponse + strlen(reponse), sChecksum, strlen(sChecksum)+1);
//  strlcpy(reponse + strlen(reponse), "-E", strlen("-E")+1);
//  return reponse;
//}

// Mise en place du packet pour l'envoi d'une trame pour tous les capteurs
void setupPacket(int distance, int lineSensor1, int lineSensor2, int lineSensor3) {

  strlcpy(reponse, "S-", strlen("S-")+1);

  char sDistance[5];
  itoa(distance, sDistance, 10);
  strlcpy(reponse + strlen(reponse), sDistance, strlen(sDistance)+1);
  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);

  char sLineSensor1[5];
  itoa(lineSensor1, sLineSensor1, 10);
  strlcpy(reponse + strlen(reponse), sLineSensor1, strlen(sLineSensor1)+1);
  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);

  char sLineSensor2[5];
  itoa(lineSensor2, sLineSensor2, 10);
  strlcpy(reponse + strlen(reponse), sLineSensor2, strlen(sLineSensor2)+1);
  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);

  char sLineSensor3[5];
  itoa(lineSensor3, sLineSensor3, 10);
  strlcpy(reponse + strlen(reponse), sLineSensor3, strlen(sLineSensor3)+1);
  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);

  int iChecksum = setChecksum(reponse);
  char sChecksum[5];
  itoa(iChecksum, sChecksum, 10);
  strlcpy(reponse + strlen(reponse), sChecksum, strlen(sChecksum)+1);
  strlcpy(reponse + strlen(reponse), "-E", strlen("-E")+1);
  
}

//Mise en place du packet pour l'envoi d'une trame par capteur
//void setupPacket(char * commande, int valeur) {
//
//  char sValeur[5];
//  itoa(valeur, sValeur, 10);
//
//  strlcpy(reponse, "S-", strlen("S-")+1);
//  strlcpy(reponse + strlen(reponse), commande, strlen(commande)+1);
//  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);
//  strlcpy(reponse + strlen(reponse), sValeur, strlen(sValeur)+1);
//  strlcpy(reponse + strlen(reponse), "-", strlen("-")+1);
//  int iChecksum = setChecksum(reponse);
//  char sChecksum[5];
//  itoa(iChecksum, sChecksum, 10);
//  strlcpy(reponse + strlen(reponse), sChecksum, strlen(sChecksum)+1);
//  strlcpy(reponse + strlen(reponse), "-E", strlen("-E")+1);
//}

//Calcul du checksum pour la trame à envoyer
int setChecksum(char * message) {
  int somme = 0;
  for (unsigned int i=0; i<strlen(message); i++) {
    somme += message[i];
  }
    //Caratere de fin
    somme += '-';
    somme += 'E';
    return somme;
}
