# Projet IMA4 : Numworks & Robot
# Maxime Créteur

## Description : 

Commande d'un robot à base d'Arduino, de capteur de distance, de suiveurs de ligne à partir de la calculatrice Numworks. 

Le projet est basé sur l'OS epsilon de la calculatrice Numworks : https://github.com/numworks/epsilon ainsi que les modifications apportées par zardam : https://zardam.github.io/post/numworks-uart-over-usb/

Ce projet est constitué d'un code pour Arduino et d'un OS Numworks modifié.

## Installation : 

Le code Arduino se téléverse à travers l'éditeur Arduino.
Pour mettre l'OS modifié sur la Numworks, il faut : 
- Télécharger le code
- Le compiler avec la commande 'make'
- Brancher la Numworks au PC 
- Flasher la Numworks avec la commande 'make epsilon_flash'. Cette commande vous demandera d'effectuer un reset sur la Numworks.

## Utilisation :

La Numworks et le robot communiquent par le câble série réalisé pour le projet. On branche la partie micro-usb sur la Numworks et de l'autre côté, le fil blanc sur le RX de l'Arduino, le fil vert sur le TX et le fil noir sur GND.

Une API python de commande du robot a été implémentée sur la Numworks. Cette API se nomme 'robot'. Elle regroupe les fonctions suivantes : 
- void ledRouge() : Demande au robot d'allumer la LED rouge
- void ledVerte() : Demande au robot d'allumer la LED verte
- void moveForward() : Demande au robot d'avancer
- void moveBackward() : Demande au robot de reculer
- void moveRight() : Demande au robot de tourner à droite
- void moveLeft() : Demande au robot de tourner à gauche
- void stop() : Demande au robot de s'arrêter
- void measureSensors() : Demande au robot d'envoyer les valeurs du capteur de distance et des trois suiveurs de ligne
- int getDistanceSensorValue() : retourne la valeur du capteur de distance en mm (comprise entre 100 et 999). Nécessite au préalable l'appel à measureSensors()
- int getLineFollowerSensorGValue() : retourne la valeur du suiveur de ligne gauche (comprise entre 100 et 999). Nécessite au préalable l'appel à measureSensors()
- int getLineFollowerSensorCValue() : retourne la valeur du suiveur de ligne centre (comprise entre 100 et 999). Nécessite au préalable l'appel à measureSensors()
- int getLineFollowerSensorDValue() : retourne la valeur du suiveur de ligne droit (comprise entre 100 et 999). Nécessite au préalable l'appel à measureSensors()

Un script d'exemple d'utilisation de l'API est présent dans l'OS Numworks. Il se nomme "suiviLigne.py" et commande le robot pour qu'il suive une ligne et s'arrête en cas d'obstacle. Pour l'utiliser, il faut lancer la fonction 'go()'

